<?php
include 'include/application.php';
init();
?><!DOCTYPE html>
<html lang="en">
<head>
    <base href="/__install/">
    <meta charset="utf-8"/>
    <title>Miwix - установка сайта</title>
    <meta name="viewport" content="width=device-width" />
    <meta http-equiv="cache-control" content="no-cache">
    <meta http-equiv="expires" content="0">
    <link rel="shortcut icon" href="/__install/media/favicon.ico"/>
    <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Poppins:300,400,500,600,700"/>
    <link href="/__install/media/style.css" rel="stylesheet" type="text/css"/>
	<script>
    let tasks;
    let status;
	<? if ($_SESSION['step'] === 'step3'): ?>
	function valid_user_data() {
		let login = document.querySelector(".login_admin").value;
		if (!(/[A-Za-z]/.test(login))) {
                event.preventDefault();
                alert('Логин должен содержать буквы')
		}
		let pass = document.querySelector(".admin_password").value;
		if (!(/[A-Za-z]/.test(pass))) {
                event.preventDefault();
                alert('Пароль должен содержать буквы')
		}
		if (pass.length < 6){
                event.preventDefault();
                alert('Пароль должен быть длиннее 6 символов')
		}
		let email = document.querySelector(".admin_email").value;
		var valid = /^([A-Za-z0-9_\-\.])+\@([A-Za-z0-9_\-\.])+\.([A-Za-z]{2,4})$/;
		if (valid.test(email) == false) {
                event.preventDefault();
                alert('Укажите действующий E-mail')
		}
	}
	<? endif; ?>
    function generatePassword() {
        var length = 16,
            charset = "abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789",
            retVal = "";
        for (var i = 0, n = charset.length; i < length; ++i) {
            retVal += charset.charAt(Math.floor(Math.random() * n));
        }
        return retVal;
    }

    function run_tasks() {
        tasks = [];
        <?
        foreach (get_tasks() as $task => $title) {
            echo 'tasks.push(["' . $task . '", "' . $title . '"]);';
        }
		?>
         run();
    }

    async function run() {
        if (tasks.length > 0) {
            let task = tasks.shift();

            try {
                set(task[0], 'start');

                const response = await fetch('/__install/?task_name=' + task[0]);
                const data = await response.text();

                if (data == 'ok') {
                    set(task[0], 'ok');
					if (window.innerWidth < 980) {
						document.querySelector('#'+task[0]).scrollIntoView();
					}
                    run();
                } else {
                    set(task[0], 'error');
					document.querySelector(".install-process").innerHTML = "<span>Ошибка!!!</span>";
                }

            } catch (error) {
                set(task[0], 'error');
            }
        } else {
            document.querySelector('.install-data').classList.remove('d-none');
            document.querySelector('.install-process').classList.add('d-none');
        }
    }
		
    function set(task_name, status) {
        let elem = document.querySelector('#' + task_name);
        let classes;

        if (status == 'start') {
            elem.querySelector('.timeline-badge').setAttribute('class', 'timeline-badge');
            elem.querySelector('.timeline-badge').classList.add('bg-warning');
        } else if (status == 'ok') {
            elem.querySelector('span.label').setAttribute('class', 'label label-inline label-success font-weight-bolder');
            elem.querySelector('.timeline-badge').setAttribute('class', 'timeline-badge');
            elem.querySelector('.timeline-badge').classList.add('bg-success');
        } else if (status == 'error') {
            elem.querySelector('span.label').setAttribute('class', 'label label-inline label-danger font-weight-bolder');
            elem.querySelector('.timeline-badge').setAttribute('class', 'timeline-badge');
            elem.querySelector('.timeline-badge').classList.add('bg-error');
        }
    }

    async function checkDB() {
        try {
            const response = await fetch('/__install/?checkDB=true', {
                method: 'POST',
                headers: {
                    'Content-Type': 'application/json'
                },
                body: JSON.stringify({
                    db_host: document.getElementById('db_host').value,
                    db_name: document.getElementById('db_name').value,
                    db_user: document.getElementById('db_user').value,
                    db_pass: document.getElementById('db_pass').value
                })
            });
            const data = await response.text();
            if (data == 'ok') {
                document.getElementById('install_sys_form').submit();
            } else if (data == 'isExists') {
                if (confirm("Выбранная БД не пустая, необходимо ее очистить для продолжения установки! Вы согласны?") == true) {
                    document.getElementById('install_sys_form').submit();
                } else {
                    return false;
                }
            } else {
                alert('Ошибка соединения с MySQL! Проверьте параметры.');
            }
        } catch (error) {
        }
    }

    document.addEventListener("DOMContentLoaded", function () {
        <? if ($_SESSION['step'] === 'step3'): ?>
        let path_input = document.querySelector('#admin_path_input');
        let pass_input = document.querySelector('#admin_pass_input');
        document.querySelector('#generate_admin_path').addEventListener('click', function () {
            path_input.value = generatePassword();
        });

        document.querySelector('#generate_admin_pass').addEventListener('click', function () {
            pass_input.value = generatePassword();
        });
        <? elseif($_SESSION['step'] === 'step5'): ?>
        run_tasks();
        <? elseif($_SESSION['step'] === 'step2'): ?>
        document.querySelector('#install_sys_cancel').addEventListener('click', function () {
            checkDB();
            return;
        });
        <? endif; ?>
    });
	</script>
</head>
<body>
    <header>
		<a href="https://web-vdv.ru">
			<img alt="Logo" src="/__install/media/logo.svg" class="logo"/>
		</a>
	</header>
	<main>
	<? if (empty($_SESSION['step']) || $_SESSION['step'] === 'step1'):?>
	<?=$step=1;?>
		<article>
			<div class="main-block">
				<h5>
					Добро пожаловать!
				</h5>
				<img src="/__install/media/bg-dark.png" alt="">
				<a href="https://web-vdv.ru/cms-miwix/miwix-oferta/" class="add-link" target="_blank">Договор оферты</a>
				<a href="?action=step2"	class="btn-block text-uppercase" style="background-color: #EBEE51">Начать установку <br>согласиться с договором оферты</a>
			</div>
		</article>
	<? elseif ($_SESSION['step'] === 'step2'): ?>
	<?=$step=2;?>
		<article>
			<div class="main-block">
				<h5>
					Шаг 1. Параметры MySQL
				</h5>
				<div class="installer-text-promo">
					<form class="form" id="install_sys_form" method="POST">
						<input type="hidden" name="action" value="step3"/>
						<div class="table">
							<div class="td-1">
								<input id="db_host" class="form-control form-control-solid"
								type="text" name="db_host"
								value="<?= !empty($_SESSION['db_config']['db_host']) ? $_SESSION['db_config']['db_host'] : '127.0.0.1' ?>"
								autocomplete="off" placeholder="127.0.0.1" required/>
							</div>
							<div class="td-1">
								<input id="db_name" class="form-control form-control-solid"
								type="text" name="db_name" 
								value="<?= !empty($_SESSION['db_config']['db_name']) ? $_SESSION['db_config']['db_name'] : '' ?>"
								autocomplete="off" placeholder="Имя базы данных" required/>
							</div>
							<div class="td-1">
								<input id="db_user" class="form-control form-control-solid"
								type="text" name="db_user"
								value="<?= !empty($_SESSION['db_config']['db_user']) ? $_SESSION['db_config']['db_user'] : '' ?>"
								autocomplete="off" placeholder="Пользователь" required/>
							</div>
							<div class="td-1">
								<input id="db_pass" class="form-control form-control-solid"
								type="password" name="db_pass"
								value="<?= !empty($_SESSION['db_config']['db_pass']) ? $_SESSION['db_config']['db_pass'] : '' ?>"
								autocomplete="off" placeholder="Пароль"/>
							</div>
							<div class="td-2">
								<a href="?action=home" class="btn-hover-rise">Вернуться назад</a>
							</div>
							<div class="td-2" style="padding-left:15px;">
								<button type="button" id="install_sys_cancel" class="btn-hover-rise">
									Продолжить
								</button>
							</div>
							<div style="clear:both"></div>
						</div>
					</form>
				</div>
			</div>
		</article>								
	<? elseif ($_SESSION['step'] === 'step3'): ?>
	<?=$step=3;?>
		<article>
			<div class="main-block">
				<h5>
					Шаг 2. Системные настройки
				</h5>
				<div class="installer-text-promo">
					<form class="form" id="install_sys_form" method="POST">
					<input type="hidden" name="action" value="step4"/>
					<div class="table">
						<div class="td-1">
							<input id="admin_path_input" class="form-control form-control-solid" type="text" name="admin_path" value="<?= !empty($_SESSION['admin_config']['admin_path']) ? $_SESSION['admin_config']['admin_path'] : '' ?>" autocomplete="off" placeholder="Путь к админке (4GhQp5Ndp7Fa8J51Ff)" required/>
							<a class="add-link" style="float:right;" id="generate_admin_path">сгенерировать путь</a>
						</div>
						<div class="td-1">
							<input class="form-control form-control-solid" type="text" name="admin_name" value="<?= !empty($_SESSION['admin_config']['admin_name']) ? $_SESSION['admin_config']['admin_name'] : '' ?>" autocomplete="off" placeholder="Имя администратора" required/>
						</div>
						<div class="td-1">
							<input class="form-control form-control-solid login_admin" type="text" name="admin_login" value="<?= !empty($_SESSION['admin_config']['admin_login']) ? $_SESSION['admin_config']['admin_login'] : '' ?>" autocomplete="off" placeholder="Логин администратора" required/>
						</div>
						<div class="td-1">
							<input id="admin_pass_input" class="form-control form-control-solid admin_password" type="text" name="admin_password" value="<?= !empty($_SESSION['admin_config']['admin_password']) ? $_SESSION['admin_config']['admin_password'] : '' ?>" autocomplete="off" placeholder="Пароль администратора" required/>
							<a class="add-link" style="float: right;" id="generate_admin_pass">сгенерировать пароль</a>
						</div>
						<div class="td-1">
							<input class="form-control form-control-solid admin_email" type="text" name="admin_email" value="<?= !empty($_SESSION['admin_config']['admin_email']) ? $_SESSION['admin_config']['admin_email'] : '' ?>" autocomplete="off" placeholder="E-Mail" required/>
						</div>
						<div class="td-2">
							<a href="?action=step2" class="btn-hover-rise">Вернуться назад</a>
						</div>
						<div class="td-2" style="padding-left:15px;">
							<button type="submit" onclick="valid_user_data()" id="install_sys_cancel" class="btn-hover-rise">
								Продолжить
							</button>
						</div>
						<div style="clear:both"></div>
					</form>
					</div>
				</div>
			</div>
		</article>
	<? elseif ($_SESSION['step'] === 'step4'): ?>
	<?=$step=4;?>
		<article>
			<div class="main-block">
				<h5>
					Шаг 3. Завершение
				</h5>
				<div class="installer-text-promo">
					<div class="table form">
						<div class="td-2 left">База данных</div>
						<div class="td-2 right">MySQL</div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Хост</div>
						<div class="td-2 right"><?= $_SESSION['db_config']['db_host'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Имя</div>
						<div class="td-2 right"><?= $_SESSION['db_config']['db_name'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Пользователь</div>
						<div class="td-2 right"><?= $_SESSION['db_config']['db_user'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Пароль</div>
						<div class="td-2 right"><?= $_SESSION['db_config']['db_pass'] ?></div>
						<div style="clear:both;">&nbsp;</div>
						<div class="td-2 left">Путь к админке</div>
						<div class="td-2 right"><?= $_SESSION['admin_config']['admin_path'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Администратор</div>
						<div class="td-2 right"><?= $_SESSION['admin_config']['admin_name'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Логин</div>
						<div class="td-2 right"><?= $_SESSION['admin_config']['admin_login'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">Пароль</div>
						<div class="td-2 right"><?= $_SESSION['admin_config']['admin_password'] ?></div>
						<div style="clear:both;"></div>
						<div class="td-2 left">E-Mail</div>
						<div class="td-2 right"><?= $_SESSION['admin_config']['admin_email'] ?></div>
						<div style="clear:both;">&nbsp;</div>
						<div class="td-2" style="padding-right:15px;">
							<a href="?action=step3" class="btn-hover-rise">Вернуться назад</a>
						</div>
						<div class="td-2">
							<a href="?action=step5" class="btn-hover-rise">Приступить к установке</a>
						</div>
						<div style="clear:both"></div>
					</div>
				</div>
			</div>
		</article>
	<? elseif ($_SESSION['step'] === 'step5'): ?>
	<?=$step=5;?>
		<article>
			<div class="install-process install-success">
				<span>Установка...</span>
			</div>
			<div class="d-none install-data install-success">
				<div class="text-center">
					<h3>Установка завершена!</h3>
				</div>
				<div class="table">
					<div class="td-1">
						<div class="text-nowrap"><?= 'https://' . $_SERVER['HTTP_HOST'] . '/miwix/?secret_admin=' . $_SESSION['admin_config']['admin_path'] ?></div>
					</div>
					<div class="td-2">
						<div>Логин</div>
					</div>
					<div class="td-2">
						<div class="right"><?= $_SESSION['admin_config']['admin_login'] ?></div>
					</div>
					<div style="clear:both"></div>
					<div class="td-2">
						<div>Пароль</div>
					</div>
					<div class="td-2">
						<div class="right"><?= $_SESSION['admin_config']['admin_password'] ?></div>
					</div>
					<div style="clear:both"></div>
					<div class="td-1">
						<div>Пожалуйста, сохраните данные для входа в панель администратора!</div>
					</div>
				</div>
				<a href="/miwix/?secret_admin=<?= $_SESSION['admin_config']['admin_path'] ?>" class="btn-block" target="_blank">Перейти в панель администратора</a>
				<a href="/" class="btn-block" target="_blank">Перейти на сайт</a>
			</div>		
		</article>		
	<? endif; ?>
		<nav>
			<div class="d-flex block_install">
				<h5>
					Прогресс установки
				</h5>
				<div class="installer-text-promo">
					<div class="timeline-item" id="step_one">
						<span class="timeline-badge<?=($step > 2)?' bg-success':''?>"></span>
						<div class="timeline-content d-flex align-items-center justify-content-between">
							<span class="mr-3">
								<span class="label label-inline font-weight-bolder d-none"></span>
								Шаг 1. Параметры MySQL&nbsp;&nbsp;
							</span>
						</div>
					</div>
					<div class="timeline-item" id="step_two">
						<span class="timeline-badge<?=($step > 3)?' bg-success':''?>"></span>
						<div class="timeline-content d-flex align-items-center justify-content-between">
							<span class="mr-3">
								<span class="label label-inline font-weight-bolder d-none"></span>
								Шаг 2. Системные настройки&nbsp;&nbsp;
							</span>
						</div>
					</div>
					<div class="timeline-item" id="step_three">
						<span class="timeline-badge<?=($step > 4)?' bg-success':''?>"></span>
						<div class="timeline-content d-flex align-items-center justify-content-between">
							<span class="mr-3">
								<span class="label label-inline font-weight-bolder d-none"></span>
								Шаг 3. Процесс установки&nbsp;&nbsp;
							</span>
						</div>
					</div>
                     <? foreach (get_tasks() as $task => $title): ?>
                      <div class="timeline-item" id="<?= $task ?>">
                           <span class="timeline-badge"></span>
                           <div class="timeline-content d-flex align-items-center justify-content-between">
                                 <span class="mr-3">
                                      <span class="label label-inline font-weight-bolder d-none"></span>
                                       <?= $title ?>&nbsp;&nbsp;
                                  </span>
                          </div>
                     </div>
                     <? endforeach; ?>
				</div>
			</div>
      </nav>
      <aside>
        <div class="sidebar">
            <h2>Добро пожаловать на страницу установки MIWIX!</h2>
			<div class="timeline">
                <div class="timeline-item">
                    <div class="timeline-content">
                        <div>Если обнаружите ошибку или посчитаете некоторые функции неудобными, пишите на email: <a href="mailto:support@miwix.ru">support@miwix.ru</a> Внесем исправления, рассмотрим ваши пожелания. Мы работаем для Вас!</div>
                   </div>
               </div>
            </div>
		</div>
	</aside>
</main>
<footer>
	<ul class="menu fw-semibold order-1">
		<li class="menu-item">
			<span class="menu-link text-white opacity-50" style="cursor: auto !important;">&copy; 2009 - 2023 MIWIX</span>
		</li>
		<li class="menu-item">
			<a href="https://web-vdv.ru/cms-miwix/miwix-oferta/" class="menu-link text-white opacity-50 opacity-100-hover" target="_blank">Договор оферты</a>
		</li>
		<li class="menu-item">
			<a href="https://web-vdv.ru/contacts/" class="menu-link text-white opacity-50 opacity-100-hover" target="_blank">Разработчик&nbsp;WEB-VDV</a>
		</li>
	</ul>
</footer>
</body>
</html>